{
  open Token
  exception Lexing_error of string
  exception Lexing_eof_in_comment
}
let space=[' ''\n''\t']
let digit=['0'-'9']

rule next_token = parse
    | digit+ { INT(int_of_string(Lexing.lexeme lexbuf)) }
    | space* { next_token lexbuf }
    | "(*"   { token_after_comment lexbuf }
    | eof    { EOF }
    | _      { raise (Lexing_error (Lexing.lexeme lexbuf)) }
and token_after_comment = parse
    | "*)"  { next_token lexbuf }
    | eof   { raise Lexing_eof_in_comment }
    | _     { token_after_comment lexbuf }
