{
  open Token
  exception Lexing_error of string
}
let space=[' ''\n''\t']
let letter=['A'-'Z''a'-'z']
let digit=['0'-'9']

rule next_token = parse
    | "begin"  { BEGIN }
    | "end"    { END }
    | "class"  { CLASS }
    | digit+   { INT(int_of_string(Lexing.lexeme lexbuf)) }
    | letter(letter|digit)*  { ID(Lexing.lexeme lexbuf) }
    | space* { next_token lexbuf }
    | eof  { EOF }
    | _    { raise (Lexing_error (Lexing.lexeme lexbuf)) }
