{
  open Token
  exception Lexing_error of string

  let keyword_table = Hashtbl.create 3;;
  List.iter (fun (kwd, tok) -> Hashtbl.add keyword_table kwd tok)
              [ ("begin", BEGIN);
                ("end", END);
                ("class", CLASS) ]
}
let space=[' ''\n''\t']
let letter=['A'-'Z''a'-'z']
let digit=['0'-'9']

rule next_token = parse
    | digit+   { INT(int_of_string(Lexing.lexeme lexbuf)) }
    | letter(letter|digit)* as id
      {try Hashtbl.find keyword_table id
       with Not_found -> ID id }
    | space* { next_token lexbuf }
    | eof  { EOF }
    | _    { raise (Lexing_error (Lexing.lexeme lexbuf)) }
